Skip to main content

Dynamic Programming - Hard Level - Question 3

Dynamic Programming - Hard Level - Question 3


Leetcode 1955 Count Number of Special Subsequences

A sequence is special if it consists of a positive number of 0s, followed by a positive number of 1s, then a positive number of 2s.

For example, [0,1,2] and [0,0,1,1,1,2] are special.

In contrast, [2,1,0], [1], and [0,1,2,0] are not special.

Given an array nums (consisting of only integers 0, 1, and 2), return the number of different subsequences that are special. Since the answer may be very large, return it modulo 10^9 + 7.

A subsequence of an array is a sequence that can be derived from the array by deleting some or no elements without changing the order of the remaining elements. Two subsequences are different if the set of indices chosen are different.

Constraints:

1 <= nums.length <= 10^5

0 <= nums[i] <= 2


Analysis:

For each element, there are three different choices: 0, 1, or 2.

Let focus on the 0 element first. If one element is 0, then there are two kinds of subsequences ending with 0:

A. the subsequences ending with previous 0's;

B. the subsequences ending with the current 0.

If we define a variable, sum0, to record the number of A, then number of B is sum0 + 1. Why?

Because 

1. each of the previous subsequence can be combined with the current 0 to form a new subsequence, which gives the number of sum0 in total;

2. the current 0 itself can form a new subsequence, which gives 1.

When the current 0 becomes one of the previous 0's, we need to update sum0 = sum0 + (sum0 + 1), to make it include both A and B.

Similarly, we can obtain the following formula for the numbers of subsequences ending with 1 and 2.

sum1 = sum1 + (sum1 + sum0)

sum2 = sum2 + (sum2 + sum1)


See the code below:


class Solution {
public:
    int countSpecialSubsequences(vector<int>& nums) {
        long mod = 1e9+7, sum0 = 0, sum1 = 0, sum2 = 0;
        int n = nums.size();
        for(int i=1; i<=n; ++i) {
            if(nums[i-1] == 0) {
                // sum0: the number of subsequences ending with all previous 0s
                // sum0 + 1:  the number of subsequence ending with the current 0
                sum0 += sum0 + 1;
                sum0 %= mod;
            }
            else if(nums[i-1] == 1) {
                // sum1: the number of subsequences ending with all previous 1s
                // sum1 + sum0:  the number of subsequence ending with the current 1
                sum1 += sum1 + sum0;
                sum1 %= mod;
            }
            else {
                // sum2: the number of subsequences ending with all previous 2s
                // sum2 + sum1:  the number of subsequence ending with the current 2
                sum2 += sum2 + sum1;
                sum2 %= mod;
            }
        }
        return sum2;
    }
};


Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once. We

Binary Search - Hard Level - Question 3

Binary Search - Hard Level - Question 3 878. Nth Magical Number A positive integer is magical if it is divisible by either a or b. Given the three integers n, a, and b, return the nth magical number. Since the answer may be very large, return it modulo 10^9 + 7. Analysis: Let us consider some examples first. Example 1, a = 4, b = 2. If b is dividable by a, then all the numbers which is dividable by a should be dividable by b as well. So the nth magical number should be n*b; Example 2, a = 3, b = 2. The multiples of 2 are: 2, 4, 6, 8, 10, 12, ... The multiple of 3 are: 3, 6, 9, 12, ... So the overlap is related to the minimum common multiple between a and b, and we need to remove the overlap which is double-counted. So now, we make some conclusions: 1. the upper bound of the nth magical number should be n*b, where a is the smaller one (or b <= a); 2. there are n*b/a magical numbers smaller than n*b; 3. there are n*b/(minimum common multiple) overlaps. Thus, the overall count is: n +

Recursion - Example

Recursion - Example Leetcode 231  Power of Two Given an integer n, return true if it is a power of two. Otherwise, return false. An integer n is a power of two, if there exists an integer x such that n == 2^x Constraints: -2^31 <= n <= 2^31 - 1 Analysis: One way is to think about this question recursively: if n%2 == 1, then n must not be power of 2; if not, then we just need to consider whether (n/2) is a power of 2 or not. This is exactly the "same question with a smaller size"! It is trivial to figure out the base cases: if n == 0, return false; if n == 1, return true. See the code below: class Solution { public: bool isPowerOfTwo(int n) { // base cases if(n == 0) return false; if(n == 1) return true; // converging if(n%2 == 1) return false; return isPowerOfTwo(n/2); } }; If interested, there are some other ways to solve this problem. For example, using bit manipulation, we can have the following solution: class